diff --git a/gcc/tree-vect-slp.c b/gcc/tree-vect-slp.c
index c151512..5b1d61c 100644
--- a/gcc/tree-vect-slp.c
+++ b/gcc/tree-vect-slp.c
@@ -352,7 +352,7 @@ again:
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	      OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "Build SLP failed: can't analyze def for ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
               dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -388,7 +388,7 @@ again:
 
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		  OPTINFO_VECT_FAILURE << optinfo_printf (
 					 "Build SLP failed: some of the stmts"
 					 " are in a pattern, and others are not ");
 		  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
@@ -404,7 +404,7 @@ again:
           if (dt == vect_unknown_def_type)
             {
               if (optinfo_enabled_p ())
-                EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+                OPTINFO_VECT_FAILURE << optinfo_printf (
 				       "Unsupported pattern");
               return -1;
             }
@@ -417,7 +417,7 @@ again:
 
 	    default:
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				 "unsupported defining stmt:\n");
 	      return -1;
             }
@@ -459,7 +459,7 @@ again:
 		}
 
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				 "Build SLP failed: different types\n");
 
 	      return 1;
@@ -473,7 +473,7 @@ again:
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		  OPTINFO_VECT_FAILURE << optinfo_printf (
 				   "Build SLP failed: invalid type of def "
 				   "for variable-length SLP ");
 		  dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
@@ -500,7 +500,7 @@ again:
 	  /* FORNOW: Not supported.  */
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	      OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "Build SLP failed: illegal type of def ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, oprnd);
               dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -519,10 +519,10 @@ again:
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
-			       "Build SLP failed: cannot swap operands of "
-			       "shared stmt ");
-	      dump_gimple_stmt (MSG_MISSED_OPTIMIZATION, TDF_SLIM, stmt, 0);
+	      OPTINFO_VECT_FAILURE 
+		<< ("Build SLP failed: cannot swap operands of "
+		    "shared stmt ")
+		<< stmt;
 	    }
 	  return -1;
 	}
@@ -555,7 +555,7 @@ again:
 			   gimple_assign_rhs2_ptr (stmt));
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 			   "swapped operands to match def types in ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	}
@@ -580,7 +580,7 @@ vect_record_max_nunits (vec_info *vinfo, gimple *stmt, unsigned int group_size,
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	  OPTINFO_VECT_FAILURE
 	    << "Build SLP failed: unsupported data-type in "
 	    << stmt;
 	}
@@ -596,7 +596,7 @@ vect_record_max_nunits (vec_info *vinfo, gimple *stmt, unsigned int group_size,
       && (!nunits.is_constant (&const_nunits)
 	  || const_nunits > group_size))
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+      OPTINFO_VECT_FAILURE
 	<< ("Build SLP failed: unrolling required "
 	    "in basic block SLP");
       /* Fatal mismatch.  */
@@ -652,7 +652,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "Build SLP for ");
+	  OPTINFO_VECT_REMARK << optinfo_printf ( "Build SLP for ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	}
 
@@ -661,7 +661,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
         {
           if (optinfo_enabled_p ())
             {
-              EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+              OPTINFO_VECT_FAILURE
 		<< "Build SLP failed: unvectorizable statement "
 		<< stmt;
             }
@@ -675,7 +675,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	      OPTINFO_VECT_FAILURE
 		<< ("Build SLP failed: not GIMPLE_ASSIGN nor "
 		    "GIMPLE_CALL ")
 		<< stmt;
@@ -706,7 +706,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << "Build SLP failed: unsupported call type "
 		    << call_stmt;
 		}
@@ -745,7 +745,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		  if (!optab)
 		    {
 		      if (optinfo_enabled_p ())
-			EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+			OPTINFO_VECT_FAILURE
 			  << "Build SLP failed: no optab";
 		      /* Fatal mismatch.  */
 		      matches[0] = false;
@@ -755,7 +755,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		  if (icode == CODE_FOR_nothing)
 		    {
 		      if (optinfo_enabled_p ())
-			EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+			OPTINFO_VECT_FAILURE
 			  << ("Build SLP failed: "
 			      "op not supported by target");
 		      /* Fatal mismatch.  */
@@ -802,7 +802,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << ("Build SLP failed: different operation "
 			"in stmt ")
 		    << stmt
@@ -818,7 +818,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << ("Build SLP failed: different shift "
 			"arguments in ")
 		    << stmt;
@@ -838,7 +838,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		{
 		  if (optinfo_enabled_p ())
 		    {
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		      OPTINFO_VECT_FAILURE
 			<< "Build SLP failed: different calls in "
 			<< stmt;
 		    }
@@ -868,7 +868,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
                     {
                       if (optinfo_enabled_p ())
                         {
-			  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+			  OPTINFO_VECT_FAILURE
 			    <<  ("Build SLP failed: different "
 				 "interleaving chains in one node ")
 			    << stmt;
@@ -888,7 +888,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	      /* Not grouped load.  */
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << "Build SLP failed: not grouped load "
 		    << stmt;
 		}
@@ -908,7 +908,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 	    {
 	      if (optinfo_enabled_p ())
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << "Build SLP failed: operation unsupported "
 		    << stmt;
 		}
@@ -945,7 +945,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		{
 		  if (optinfo_enabled_p ())
 		    {
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		      OPTINFO_VECT_FAILURE
 			<< "Build SLP failed: different operation"
 			<< stmt;
 		    }
@@ -972,7 +972,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
       if (!nunits.is_constant (&count))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+	    OPTINFO_VECT_FAILURE
 	      << ("Build SLP failed: different operations "
 		  "not allowed with variable-length SLP");
 	  return false;
@@ -994,7 +994,7 @@ vect_build_slp_tree_1 (vec_info *vinfo, unsigned char *swap,
 		matches[i] = false;
 		if (optinfo_enabled_p ())
 		  {
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		    OPTINFO_VECT_FAILURE
 		      << ("Build SLP failed: different operation "
 			  "in stmt ")
 		      << stmts[i]
@@ -1246,7 +1246,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 		    vect_free_slp_tree (grandchild);
 		  SLP_TREE_CHILDREN (child).truncate (0);
 
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+		  OPTINFO_VECT_REMARK << optinfo_printf (
 				   "Building parent vector operands from "
 				   "scalars instead\n");
 		  oprnd_info->def_stmts = vNULL;
@@ -1276,7 +1276,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 	     scalar version.  */
 	  && !is_pattern_stmt_p (vinfo_for_stmt (stmt)))
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 			   "Building vector operands from scalars\n");
 	  child = vect_create_new_slp_node (oprnd_info->def_stmts);
 	  SLP_TREE_DEF_TYPE (child) = vect_external_def;
@@ -1334,7 +1334,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 			{
 			  if (optinfo_enabled_p ())
 			    {
-			      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+			      OPTINFO_VECT_FAILURE
 				<< ("Build SLP failed: cannot swap "
 				    "operands of shared stmt ")
 				<< stmts[j];
@@ -1349,7 +1349,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 	  while (j != group_size);
 
 	  /* Swap mismatched definition stmts.  */
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 			   "Re-trying with swapped operands of stmts ");
 	  for (j = 0; j < group_size; ++j)
 	    if (matches[j] == !swap_not_matching)
@@ -1424,7 +1424,7 @@ vect_build_slp_tree_2 (vec_info *vinfo,
 			vect_free_slp_tree (grandchild);
 		      SLP_TREE_CHILDREN (child).truncate (0);
 
-		      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+		      OPTINFO_VECT_REMARK << optinfo_printf (
 				       "Building parent vector operands from "
 				       "scalars instead\n");
 		      oprnd_info->def_stmts = vNULL;
@@ -1644,7 +1644,7 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
 
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "Load permutation ");
+      OPTINFO_VECT_REMARK << optinfo_printf ( "Load permutation ");
       FOR_EACH_VEC_ELT (SLP_INSTANCE_LOADS (slp_instn), i, node)
 	if (node->load_permutation.exists ())
 	  FOR_EACH_VEC_ELT (node->load_permutation, j, next)
@@ -1719,7 +1719,7 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
 	      if (!TYPE_VECTOR_SUBPARTS (vectype).is_constant (&nunits)
 		  || maxk >= (GROUP_SIZE (group_info) & ~(nunits - 1)))
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << ("BB vectorization with gaps at the end of "
 			"a load is not supported");
 		  return false;
@@ -1731,7 +1731,7 @@ vect_supported_load_permutation_p (slp_instance slp_instn)
 	      if (!vect_transform_slp_perm_load (node, tem, NULL,
 						 1, slp_instn, true, &n_perms))
 		{
-		  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+		  OPTINFO_VECT_FAILURE
 		    << "unsupported load permutation";
 		  return false;
 		}
@@ -2100,7 +2100,7 @@ vect_split_slp_store_group (gimple *first_stmt, unsigned group1_size)
   GROUP_GAP (first_vinfo) += group2_size;
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "Split group into %d and %d\n",
+    OPTINFO_VECT_REMARK << optinfo_printf ( "Split group into %d and %d\n",
 		     group1_size, group2_size);
 
   return group2;
@@ -2159,7 +2159,7 @@ vect_analyze_slp_instance (vec_info *vinfo,
     {
       if (optinfo_enabled_p ())
         {
-          EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+          OPTINFO_VECT_FAILURE << optinfo_printf (
 			   "Build SLP failed: unsupported data-type ");
           dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM, scalar_type);
           dump_printf (MSG_MISSED_OPTIMIZATION, "\n");
@@ -2224,7 +2224,7 @@ vect_analyze_slp_instance (vec_info *vinfo,
 	      || const_max_nunits > group_size)
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				 "Build SLP failed: store group "
 				 "size not a multiple of the vector size "
 				 "in basic block SLP\n");
@@ -2288,7 +2288,7 @@ vect_analyze_slp_instance (vec_info *vinfo,
             {
               if (optinfo_enabled_p ())
                 {
-                  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
+                  OPTINFO_VECT_FAILURE
 		    << ("Build SLP failed: unsupported load "
 			"permutation ")
 		    << stmt;
@@ -2321,7 +2321,7 @@ vect_analyze_slp_instance (vec_info *vinfo,
 	  if (i == loads.length ())
 	    {
 	      if (optinfo_enabled_p ())
-		EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+		OPTINFO_VECT_FAILURE << optinfo_printf (
 				 "Built SLP cancelled: can use "
 				 "load/store-lanes\n");
 	      vect_free_slp_instance (new_instance);
@@ -2333,7 +2333,7 @@ vect_analyze_slp_instance (vec_info *vinfo,
 
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 			   "Final SLP tree for instance:\n");
 	  vect_print_slp_tree (MSG_NOTE, vect_location, node);
 	}
@@ -2474,7 +2474,7 @@ vect_make_slp_decision (loop_vec_info loop_vinfo)
 
   if (decided_to_slp && optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+      OPTINFO_VECT_REMARK << optinfo_printf (
 		       "Decided to SLP %d instances. Unrolling factor ",
 		       decided_to_slp);
       dump_dec (MSG_NOTE, unrolling_factor);
@@ -2536,7 +2536,7 @@ vect_detect_hybrid_slp_stmts (slp_tree node, unsigned i, slp_vect_type stype)
 	      {
 		if (optinfo_enabled_p ())
 		  {
-		    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "use of SLP "
+		    OPTINFO_VECT_REMARK << optinfo_printf ( "use of SLP "
 				     "def in non-SLP stmt: ");
 		    dump_gimple_stmt (MSG_NOTE, TDF_SLIM, use_stmt, 0);
 		  }
@@ -2550,7 +2550,7 @@ vect_detect_hybrid_slp_stmts (slp_tree node, unsigned i, slp_vect_type stype)
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "marking hybrid: ");
+	  OPTINFO_VECT_REMARK << optinfo_printf ( "marking hybrid: ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM, stmt, 0);
 	}
       STMT_SLP_TYPE (stmt_vinfo) = hybrid;
@@ -2581,7 +2581,7 @@ vect_detect_hybrid_slp_1 (tree *tp, int *, void *data)
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "marking hybrid: ");
+	      OPTINFO_VECT_REMARK << optinfo_printf ( "marking hybrid: ");
 	      dump_gimple_stmt (MSG_NOTE, TDF_SLIM, def_stmt, 0);
 	    }
 	  STMT_SLP_TYPE (vinfo_for_stmt (def_stmt)) = hybrid;
@@ -2743,7 +2743,7 @@ vect_slp_analyze_node_operations (vec_info *vinfo, slp_tree node,
       tree scalar_type = TREE_TYPE (gimple_get_lhs (stmt));
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 			   "get vectype for scalar type:  ");
 	  dump_generic_expr (MSG_NOTE, TDF_SLIM, scalar_type);
 	  dump_printf (MSG_NOTE, "\n");
@@ -2754,7 +2754,7 @@ vect_slp_analyze_node_operations (vec_info *vinfo, slp_tree node,
 	{
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	      OPTINFO_VECT_FAILURE << optinfo_printf (
 			       "not SLPed: unsupported data-type ");
 	      dump_generic_expr (MSG_MISSED_OPTIMIZATION, TDF_SLIM,
 				 scalar_type);
@@ -2765,7 +2765,7 @@ vect_slp_analyze_node_operations (vec_info *vinfo, slp_tree node,
 
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "vectype:  ");
+	  OPTINFO_VECT_REMARK << optinfo_printf ( "vectype:  ");
 	  dump_generic_expr (MSG_NOTE, TDF_SLIM, vectype);
 	  dump_printf (MSG_NOTE, "\n");
 	}
@@ -2833,7 +2833,7 @@ vect_slp_analyze_operations (vec_info *vinfo)
 					     SLP_INSTANCE_TREE (instance),
 					     instance))
         {
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	  OPTINFO_VECT_REMARK
 	    << "removing SLP instance operations starting from: "
 	    << SLP_TREE_SCALAR_STMTS (SLP_INSTANCE_TREE (instance))[0];
 	  vect_free_slp_instance (instance);
@@ -2971,7 +2971,7 @@ vect_bb_vectorization_profitable_p (bb_vec_info bb_vinfo)
 
   if (optinfo_enabled_p ())
     {
-      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf ( "Cost model analysis: \n");
+      OPTINFO_VECT_REMARK << optinfo_printf ( "Cost model analysis: \n");
       dump_printf (MSG_NOTE, "  Vector inside of basic block cost: %d\n",
 		   vec_inside_cost);
       dump_printf (MSG_NOTE, "  Vector prologue cost: %d\n", vec_prologue_cost);
@@ -3011,7 +3011,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
   if (n_stmts > PARAM_VALUE (PARAM_SLP_MAX_INSNS_IN_BB))
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not vectorized: too many instructions in "
 			 "basic block.\n");
       free_data_refs (datarefs);
@@ -3029,7 +3029,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
   if (!vect_analyze_data_refs (bb_vinfo, &min_vf))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not vectorized: unhandled data-ref in basic "
 			 "block");
 
@@ -3040,7 +3040,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
   if (BB_VINFO_DATAREFS (bb_vinfo).length () < 2)
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not vectorized: not enough data-refs in "
 			 "basic block");
 
@@ -3051,7 +3051,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
   if (!vect_analyze_data_ref_accesses (bb_vinfo))
     {
      if (optinfo_enabled_p ())
-       EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+       OPTINFO_VECT_FAILURE << optinfo_printf (
 			"not vectorized: unhandled data access in "
 			"basic block");
 
@@ -3065,7 +3065,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
   if (bb_vinfo->grouped_stores.is_empty ())
     {
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not vectorized: no grouped stores in "
 			 "basic block.\n");
 
@@ -3084,9 +3084,9 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
     {
       if (optinfo_enabled_p ())
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+	  OPTINFO_VECT_FAILURE << optinfo_printf (
 			   "Failed to SLP the basic block.\n");
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf ( 
+	  OPTINFO_VECT_FAILURE << optinfo_printf ( 
 			   "not vectorized: failed to find SLP opportunities "
 			   "in basic block.\n");
 	}
@@ -3104,7 +3104,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
       if (! vect_slp_analyze_and_verify_instance_alignment (instance)
 	  || ! vect_slp_analyze_instance_dependence (instance))
 	{
-	  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+	  OPTINFO_VECT_REMARK << optinfo_printf (
 			   "removing SLP instance operations starting from: ");
 	  dump_gimple_stmt (MSG_NOTE, TDF_SLIM,
 			    SLP_TREE_SCALAR_STMTS
@@ -3130,7 +3130,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
   if (!vect_slp_analyze_operations (bb_vinfo))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not vectorized: bad operation in basic block.\n");
 
       delete bb_vinfo;
@@ -3142,7 +3142,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
       && !vect_bb_vectorization_profitable_p (bb_vinfo))
     {
       if (optinfo_enabled_p ())
-        EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE) << optinfo_printf (
+        OPTINFO_VECT_FAILURE << optinfo_printf (
 			 "not vectorized: vectorization is not "
 			 "profitable.\n");
 
@@ -3151,7 +3151,7 @@ vect_slp_analyze_bb_1 (gimple_stmt_iterator region_begin,
     }
 
   if (optinfo_enabled_p ())
-    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) << optinfo_printf (
+    OPTINFO_VECT_REMARK << optinfo_printf (
 		     "Basic block will be vectorized using SLP\n");
 
   return bb_vinfo;
@@ -3222,13 +3222,13 @@ vect_slp_bb (basic_block bb)
 	  && dbg_cnt (vect_slp))
 	{
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	    OPTINFO_VECT_REMARK
 	      << "SLPing BB part";
 
 	  vect_schedule_slp (bb_vinfo);
 
 	  if (optinfo_enabled_p ())
-	    EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	    OPTINFO_VECT_REMARK
 	      << "basic block part vectorized";
 
 	  vectorized = true;
@@ -3267,7 +3267,7 @@ vect_slp_bb (basic_block bb)
 	  current_vector_size = vector_sizes[next_size++];
 	  if (optinfo_enabled_p ())
 	    {
-	      EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK)
+	      OPTINFO_VECT_REMARK
 		<< "***** Re-trying analysis with vector size ";
 	      // FIXME:
 	      dump_dec (MSG_NOTE, current_vector_size);
@@ -3932,9 +3932,8 @@ vect_transform_slp_perm_load (slp_tree node, vec<tree> dr_chain,
 	      if (optinfo_enabled_p ())
 		{
 		  // FIXME: would be better to use "stmt" for location here:
-                  EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_FAILURE)
-		    << ("permutation requires at "
-			"least three vectors ")
+                  OPTINFO_VECT_FAILURE
+		    << "permutation requires at least three vectors "
 		    << stmt;
 		}
 	      gcc_assert (analyze_only);
@@ -4234,7 +4233,7 @@ vect_schedule_slp (vec_info *vinfo)
       is_store = vect_schedule_slp_instance (SLP_INSTANCE_TREE (instance),
                                              instance, bst_map);
       if (optinfo_enabled_p ())
-	EMIT_OPTINFO_AT_VECT_LOCATION (OPT_RECORD_REMARK) 
+	OPTINFO_VECT_REMARK 
 	  << "vectorizing stmts using SLP";
     }
   delete bst_map;
